var SV = window.SV || {};
SV.AdvancedBBCode = SV.AdvancedBBCode || {};
SV.WordCounter = SV.WordCounter || {};

(/** @param {jQuery} $ jQuery Object */ function ($, window, document, _undefined)
{
    "use strict";

    SV.AdvancedBBCode.EditorConfig = [];
    SV.AdvancedBBCode.EditorFirstStart = [];
    SV.AdvancedBBCode.EditorInit = [];
    SV.AdvancedBBCode.editorConfig = {
        dialog: [],
        tags: {
            abbr: false,
            h4: false,
        },
        wordCounter: false,
        shimH1: false,
        shimHr: false,
        pasteQuotesAsBbCode: false,
        normalizeQuoteChars: false,
        hrStyle: 0,
        disableBbCodeModeClicks: 0,
        disableDisableBbCodeModeClicks: 0,
        disableBbCodeModeClicksPhrase: '',
    };

    SV.AdvancedBBCode.EditorButtons = {

        config: function (event, config, xfEditor)
        {
            var tags = SV.AdvancedBBCode.editorConfig.tags || {};
            if (tags.abbr) {
                config.htmlAllowedTags.push('abbr');
            }

            Object.keys(SV.AdvancedBBCode.EditorConfig).forEach(function (key) {
                var func = SV.AdvancedBBCode.EditorConfig[key];
                func(SV.AdvancedBBCode.editorConfig, config, xfEditor);
            });
        },


        editorInit: function(event, ed, xfEditor)
        {
            Object.keys(SV.AdvancedBBCode.EditorInit).forEach(function (key) {
                var func = SV.AdvancedBBCode.EditorInit[key];
                func(SV.AdvancedBBCode.editorConfig, ed, xfEditor);
            });
        },

        setupConfig: function($editorConfig) {
            try
            {
                SV.AdvancedBBCode.editorConfig = $.parseJSON($editorConfig.html()) || {};
            }
            catch (e)
            {
                console.error(e);
            }
        },

        setupLanguage: function()
        {
            var lang;

            try
            {
                lang = $.parseJSON($('.js-editorLanguage-ex').first().html()) || {};
            }
            catch (e)
            {
                console.error(e);
                lang = {};
            }

            Object.keys(lang).forEach(function (key) {
                $.FE.LANGUAGE['xf'][key] = lang[key];
            })
        },


        init: function ()
        {
            var $editorConfig = $('.js-editorConfig-ex').first();
            if ($editorConfig.length === 0) {
                console.log("Failed extend editor.");
                return;
            }

            var config = SV.AdvancedBBCode.EditorButtons;

            config.setupConfig($editorConfig);
            config.setupLanguage();

            Object.keys(SV.AdvancedBBCode.EditorFirstStart).forEach(function (key) {
                var func = SV.AdvancedBBCode.EditorFirstStart[key];
                func(SV.AdvancedBBCode.editorConfig);
            });
        },
    };

    $(document).on('editor:config', SV.AdvancedBBCode.EditorButtons.config);
    $(document).on('editor:first-start', SV.AdvancedBBCode.EditorButtons.init);
    $(document).on('editor:init', SV.AdvancedBBCode.EditorButtons.editorInit);
})(jQuery, window, document);
