var SV = window.SV || {};
SV.AdvancedBBCode = SV.AdvancedBBCode || {};
SV.AdvancedBBCode.EditorButtons = SV.AdvancedBBCode.EditorButtons || {};
SV.AdvancedBBCode.EditorFirstStart = SV.AdvancedBBCode.EditorFirstStart || [];

(/** @param {jQuery} $ jQuery Object */ function ($, window, document, _undefined) {
    "use strict";

    SV.AdvancedBBCode.EditorButtons.shimToggleBbCode = function() {
        var originalFn = $.FE.PLUGINS.bbCode;
        var xf21Compat = !('isElementWithinDraftForm' in XF);
        $.FE.PLUGINS.bbCode = function(ed) {
            var obj = originalFn(ed);
            if ('btnsToDisable' in obj) {
                obj.btnsToDisable = function($button)
                {
                    return ed.$tb.find('> .fr-btn-grp .fr-command, > .fr-more-toolbar .fr-command')
                        .not($button)
                        .not('[data-cmd="fullscreen"]')
                        .not('[data-cmd^="xfDraft"]')
                        .not('[data-cmd^="more"]')
                        .not('[data-cmd=xfPreview]');
                }
            } else {
                // copied from xf\editor.js
                // the entire $.FE.PLUGINS.bbCode needs replacing to correctly shim btnsToDisable to skip draft buttons :(
                var func = function(ed)
                {
                    var _isBbCodeView = false;

                    function getButton()
                    {
                        return ed.$tb.find('.fr-command[data-cmd=xfBbCode]');
                    }

                    function getBbCodeBox()
                    {
                        var $oel = ed.$oel;

                        var $bbCodeBox = $oel.data('xfBbCodeBox');
                        if (!$bbCodeBox)
                        {
                            var borderAdjust = parseInt(ed.$wp.css('border-bottom-width'), 10)
                                + parseInt(ed.$wp.css('border-top-width'), 10);

                            $bbCodeBox = $('<textarea class="input" style="display: none" />');
                            $bbCodeBox.attr('aria-label', XF.htmlspecialchars(XF.phrase('rich_text_box')));
                            $bbCodeBox.css({
                                minHeight: ed.opts.heightMin ? (ed.opts.heightMin + borderAdjust) + 'px' : null,
                                maxHeight: ed.opts.heightMax ? ed.opts.heightMax + 'px' : null,
                                height: ed.opts.height ? (ed.opts.height + borderAdjust) + 'px' : null,
                                padding: ed.$el.css('padding')
                            });
                            $bbCodeBox.attr('name', $oel.data('original-name'));
                            $oel.data('xfBbCodeBox', $bbCodeBox);
                            ed.$wp.after($bbCodeBox[0]);

                            $bbCodeBox.on('focus blur', function(e)
                            {
                                switch (e.type)
                                {
                                    case 'focus':
                                        ed.$box.addClass('is-focused');
                                        break;

                                    case 'blur':
                                        ed.$box.removeClass('is-focused');
                                        break;
                                }
                            });

                            XF.Element.applyHandler($bbCodeBox, 'textarea-handler');
                            XF.Element.applyHandler($bbCodeBox, 'user-mentioner');
                            XF.Element.applyHandler($bbCodeBox, 'emoji-completer');

                            if (!xf21Compat && XF.isElementWithinDraftForm($bbCodeBox))
                            {
                                XF.Element.applyHandler($bbCodeBox, 'draft-trigger');
                            }
                        }

                        return $bbCodeBox;
                    }

                    function btnsToDisable($button)
                    {
                        return ed.$tb.find(xf21Compat ? ' > .fr-command' : '> .fr-btn-grp .fr-command, > .fr-more-toolbar .fr-command')
                            .not($button)
                            .not('[data-cmd="fullscreen"]')
                            .not('[data-cmd^="xfDraft"]')
                            .not('[data-cmd^="more"]')
                            .not('[data-cmd=xfPreview]');
                    }

                    function toBbCode(bbCode, skipFocus)
                    {
                        var self = this, $bbCodeBox = self.getBbCodeBox()

                        var apply = function(bbCode, skipFocus)
                        {
                            _isBbCodeView = true;

                            var $button;

                            ed.undo.saveStep();
                            ed.$el.blur();

                            $button = self.getButton();

                            self.btnsToDisable($button).addClass('fr-disabled');
                            $button.addClass('fr-active');

                            ed.$wp.css('display', 'none');
                            ed.$oel.attr('disabled', 'disabled'); // Froala jQuery doesn't implement prop

                            $bbCodeBox.val(bbCode)
                                .css('display', '')
                                .prop('disabled', false)
                                .trigger('autosize');

                            if (!skipFocus)
                            {
                                $bbCodeBox.autofocus();
                            }

                            XF.setIsEditorEnabled(false);
                        };

                        if (typeof bbCode == 'string')
                        {
                            apply(bbCode, skipFocus);
                        }
                        else
                        {
                            XF.ajax('POST',
                                XF.canonicalizeUrl('index.php?editor/to-bb-code'),
                                { html: ed.html.get() },
                                function (data) { apply(data.bbCode, skipFocus); }
                            );
                        }
                    }

                    function toHtml(html)
                    {
                        var self = this, $bbCodeBox = self.getBbCodeBox()

                        var apply = function(html)
                        {
                            _isBbCodeView = false;

                            var $button = getButton();

                            self.btnsToDisable($button).removeClass('fr-disabled');
                            $button.removeClass('fr-active');

                            ed.$oel.removeAttr('disabled'); // Froala jQuery doesn't implement prop
                            ed.html.set(html);
                            $bbCodeBox.css('display', 'none').prop('disabled', true);
                            ed.$wp.css('display', '');
                            ed.events.focus();
                            ed.undo.saveStep();
                            ed.size.refresh();

                            XF.setIsEditorEnabled(true);
                            XF.layoutChange();
                        };

                        if (typeof html == 'string')
                        {
                            apply(html);
                        }
                        else
                        {
                            var params = { bb_code: $bbCodeBox.val() };

                            var $form = ed.$el.closest('form');
                            if ($form.length)
                            {
                                if ($form[0][ed.opts.xfBbCodeAttachmentContextInput])
                                {
                                    params.attachment_hash_combined = $($form[0][ed.opts.xfBbCodeAttachmentContextInput]).val();
                                }
                            }

                            XF.ajax('POST',
                                XF.canonicalizeUrl('index.php?editor/to-html'),
                                params,
                                function (data) { apply(data.editorHtml); }
                            );
                        }
                    }

                    function toggle()
                    {
                        if (_isBbCodeView)
                        {
                            this.toHtml();
                        }
                        else
                        {
                            this.toBbCode();
                        }
                    }

                    function isBbCodeView()
                    {
                        return _isBbCodeView;
                    }

                    function getToggleableButtons()
                    {
                        return this.btnsToDisable(getButton());
                    }

                    function insertBbCode(bbCode)
                    {
                        if (!_isBbCodeView)
                        {
                            return;
                        }

                        var $bbCodeBox = this.getBbCodeBox();
                        XF.insertIntoTextBox($bbCodeBox, bbCode);
                    }

                    function replaceBbCode(bbCode)
                    {
                        if (!_isBbCodeView)
                        {
                            return;
                        }

                        var $bbCodeBox = this.getBbCodeBox();
                        XF.replaceIntoTextBox($bbCodeBox, bbCode);
                    }

                    function getTextArea()
                    {
                        return (_isBbCodeView ? this.getBbCodeBox() : null);
                    }

                    function _init()
                    {
                        ed.events.on('buttons.refresh', function()
                        {
                            return !_isBbCodeView;
                        });
                    }

                    return {
                        _init: _init,
                        btnsToDisable: btnsToDisable,
                        getButton: getButton,
                        getBbCodeBox: getBbCodeBox,
                        toBbCode: toBbCode,
                        isBbCodeView: isBbCodeView,
                        getTextArea: getTextArea,
                        insertBbCode: insertBbCode,
                        replaceBbCode: replaceBbCode,
                        toHtml: toHtml,
                        toggle: toggle,
                        getToggleableButtons: getToggleableButtons
                    };
                };

                obj = func(ed);
            }
            return obj;
        };
    };

    SV.AdvancedBBCode.EditorFirstStart.push(function(editorConfig) {
        if ($.FE.PLUGINS.bbCode) {
            SV.AdvancedBBCode.EditorButtons.shimToggleBbCode();
        }
    });

})(jQuery, window, document);
