var SV = window.SV || {};
SV.AdvancedBBCode = SV.AdvancedBBCode || {};

(/** @param {jQuery} $ jQuery Object */ function ($, window, document, _undefined) {
    "use strict";

    XF.Element.extend('textarea-handler', {
        __backup: {
            'init': 'svAdvancedBbCode_disableClicker_init'
        },

        setupDisableClickerWatcher: function(editor, disableBbCodeModeClicks, disableDisableBbCodeModeClicks) {
            var ed = editor.ed,
                enable = true;
            ed.svDisabledClicks = 0;
            ed.svDisabledClicksAttempts = 0;
            ed.$tb.on('click', 'button.fr-disabled', function() {
                if(enable && ed.bbCode.isBbCodeView()) {
                    ed.svDisabledClicks += 1;
                    if(ed.svDisabledClicks >= disableBbCodeModeClicks) {
                        ed.svDisabledClicks = 0;
                        if(confirm(XF.phrase('svAdvancedBbCodesPack_bbcode_mode_button_usage'))) {
                            ed.bbCode.toggle();
                        } else {
                            ed.svDisabledClicksAttempts += 1;
                            if (ed.svDisabledClicksAttempts >= disableDisableBbCodeModeClicks) {
                                enable = false;
                            }
                        }
                    }
                }
            });
        },

        init: function() {
            var self = this,
                editor = null,
                $container = this.$target.closest('.message-editorWrapper');
            if ($container.length) {
                editor = XF.getEditorInContainer($container);
            }
            if (!editor) {
                $container = this.$target.closest('.bbWrapper').parent();
                if ($container.length) {
                    editor = XF.getEditorInContainer($container);
                } else {
                    return;
                }
            }
            if (editor) {
                var disableBbCodeModeClicks = SV.AdvancedBBCode.editorConfig.disableBbCodeModeClicks | 0;
                var disableDisableBbCodeModeClicks = SV.AdvancedBBCode.editorConfig.disableDisableBbCodeModeClicks | 0;
                var disableBbCodeModeClicksPhrase = SV.AdvancedBBCode.editorConfig.disableBbCodeModeClicksPhrase || '';
                if (disableBbCodeModeClicks > 0 && disableBbCodeModeClicksPhrase) {
                    XF.phrases['svAdvancedBbCodesPack_bbcode_mode_button_usage'] = disableBbCodeModeClicksPhrase;
                    this.setupDisableClickerWatcher(editor, disableBbCodeModeClicks, disableDisableBbCodeModeClicks);
                }
            } else {
                console.log('Failed to locate editor');
            }

            this.svAdvancedBbCode_disableClicker_init();
        },
    });
})(jQuery, window, document);
