var SV = window.SV || {};
SV.AdvancedBBCode = SV.AdvancedBBCode || {};
SV.AdvancedBBCode.EditorButtons = SV.AdvancedBBCode.EditorButtons || {};
SV.AdvancedBBCode.EditorFirstStart = SV.AdvancedBBCode.EditorFirstStart || [];

(/** @param {jQuery} $ jQuery Object */ function ($, window, document, _undefined) {
    "use strict";

    XF.Editor = XF.extend(XF.Editor, {
        __backup: {
            'editorInit': 'svAdvancedBbCode_fullscreen_editorInit',
        },

        editorInit: function () {
            // Workaround for Froala not updating on resize
            // See https://github.com/froala/react-froala-wysiwyg/issues/234#issuecomment-608976725

            this.svAdvancedBbCode_fullscreen_editorInit();

            this.ed.events.on('commands.before', function (cmd) {
                if (cmd === 'fullscreen') {
                    setTimeout(() => window.dispatchEvent(new Event('resize')), 0);
                }
            });
        },
    });

    SV.AdvancedBBCode.EditorButtons.shimToggleFullscreen = function () {
        var originalFn = $.FE.PLUGINS.fullscreen;
        $.FE.PLUGINS.fullscreen = function (ed) {
            var obj = originalFn(ed);
            var originalToggleFunc = obj.toggle;
            obj.toggle = function () {
                var ret = originalToggleFunc();

                var $editor = $(ed.$box.get(0));
                var $textarea = $editor.find('textarea.input');
                if ($editor.length !== 0) {
                    if (!obj.isActive()) {
                        var $container = $editor.closest('.message-editorWrapper');
                        if ($container.length) {
                            XF.focusEditor($container);
                            // focus *again* to move a little once the stick-nav becomes visible
                            if ($(".p-navSticky").length !== 0) {
                                setTimeout(function () {
                                    XF.focusEditor($container);
                                }, 0);
                            }
                        }

                        // older froala versions
                        if ($textarea.length !== 0) {
                            var minHeight = $textarea.data('min-height');
                            var maxHeight = $textarea.data('max-height');
                            if (minHeight && maxHeight) {
                                $textarea.css({
                                    'min-height': minHeight,
                                    'max-height': maxHeight
                                });
                                $textarea.data('min-height', 0);
                                $textarea.data('max-height', 0);
                                // force height re-calc
                                $textarea.val($textarea.val());
                            }
                        } else {
                            // resize <textarea> to match the screen (for XF2.1)
                            $textarea.data('min-height', $textarea.css('min-height'));
                            $textarea.data('max-height', $textarea.css('max-height'));
                            $textarea.css({
                                'height': '100%',
                                'min-height': '100%',
                                'max-height': '100%'
                            });
                        }
                    }
                }

                return ret;
            }

            return obj;
        };
    };

    SV.AdvancedBBCode.EditorFirstStart.push(function (editorConfig) {
        if ($.FE.PLUGINS.fullscreen) {
            SV.AdvancedBBCode.EditorButtons.shimToggleFullscreen();
        }
    });

})(jQuery, window, document);
