var SV = window.SV || {};
SV.AdvancedBBCode = SV.AdvancedBBCode || {};
SV.AdvancedBBCode.EditorButtons = SV.AdvancedBBCode.EditorButtons || {};
SV.AdvancedBBCode.EditorFirstStart = SV.AdvancedBBCode.EditorFirstStart || [];

(/** @param {jQuery} $ jQuery Object */ function ($, window, document, _undefined) {
    "use strict";

    SV.AdvancedBBCode.EditorButtons.setupShimParagraphStyle = function(cmd) {
        var oldCallback = cmd.callback;
        cmd.callback = function (c, tag) {
            var ed = this;
            oldCallback.apply(ed, [c, tag]);
            // patch css
            ed.$el.find('h1:not(.bbc-header),h2:not(.bbc-header),h3:not(.bbc-header),h4:not(.bbc-header)').addClass('bbc-header');
            ed.$el.find('p.bbc-header, span.bbc-header, div.bbc-header').removeClass('bbc-header');
        };
    };

    SV.AdvancedBBCode.EditorFirstStart.push(function(editorConfig) {
        if (editorConfig.shimH1) {
            // register our temp bb-codes as block-like tags
            $.FE.BLOCK_TAGS.push('svbbcode_h1');
            $.FE.BLOCK_TAGS.push('svbbcode_h2');
            $.FE.BLOCK_TAGS.push('svbbcode_h3');
            $.FE.BLOCK_TAGS.push('svbbcode_h4');

            if ($.FE.COMMANDS['paragraphFormat']) {
                SV.AdvancedBBCode.EditorButtons.setupShimParagraphStyle($.FE.COMMANDS['paragraphFormat']);
            }
        }
    });

    SV.AdvancedBBCode.EditorConfig.push(function (editorConfig, config, ed, xfEditor) {
        if (editorConfig.shimH1) {
            config.paragraphFormat = {
                N: 'Normal',
                H1: 'Heading 1',
                H2: 'Heading 2',
                H3: 'Heading 3'
            };
            var tags = SV.AdvancedBBCode.editorConfig.tags || {};
            if (tags.h4) {
                config.paragraphFormat['H4'] = 'Heading 4';
            }
        }
    });
})(jQuery, window, document);
