var SV = window.SV || {};
SV.AdvancedBBCode = SV.AdvancedBBCode || {};
SV.AdvancedBBCode.EditorConfig = SV.AdvancedBBCode.EditorConfig || [];

(/** @param {jQuery} $ jQuery Object */ function ($, window, document, _undefined) {
    "use strict";

    XF.Element.extend('textarea-handler', {
        __backup: {
            'init': 'svAdvancedBbCode_wordCounter_init'
        },

        init: function() {
            var self = this,
                editor = null,
                $container = this.$target.closest('.message-editorWrapper');
            if ($container.length) {
                editor = XF.getEditorInContainer($container);
            }
            if (!editor) {
                $container = this.$target.closest('.bbWrapper').parent();
                if ($container.length) {
                    editor = XF.getEditorInContainer($container);
                } else {
                    return;
                }
            }
            if (editor) {
                editor.ed.events.on('html.set', function(){
                    editor.ed.opts.wordCounterGetText = null;
                });
                this.$target.on('autosize', function () {
                    if (!self.$target.prop('disabled')) {
                        if (!editor.ed.opts.wordCounterGetText) {
                            // patch the option to allow shimming the source text
                            editor.ed.opts.wordCounterGetText = function () {
                                return self.$target.val();
                            };
                        }
                        editor.ed.events.trigger('charCounter.update');
                    } else {
                        editor.ed.opts.wordCounterGetText = null;
                    }
                });

                // doesn't work reliably for IE9 or older, who cares.
                this.$target.on('input', function () {
                    if (editor.ed.opts.wordCounterGetText) {
                        editor.ed.events.trigger('charCounter.update');
                    }
                });
            } else {
                console.log('Failed to locate editor');
            }

            this.svAdvancedBbCode_wordCounter_init();
        },
    });

    SV.AdvancedBBCode.EditorConfig.push(function (editorConfig, config, ed, xfEditor) {
        if (editorConfig.wordCounter && (typeof $.FE.DEFAULTS.wordCounter !== 'undefined')) {
            config.wordCounter = true;
            config.wordCounterBbCode = true;
            config.wordCounterLabel = XF.phrase('sv_bbcode_word_count');

            if ('svBbCodeWordCountPhrases' in XF.config)
            {
                config.wordCounterLabels = XF.config.svBbCodeWordCountPhrases;
            }

            config.wordCounterTimeout = SV.WordCounter.timeoutInterval || 0;
            if (config.wordCounterTimeout < 0) {
                config.wordCounterTimeout = 600;
            }

            if (config.pluginsEnabled)
            {
                config.pluginsEnabled.push('wordCounter');
            }
        }
    });
})(jQuery, window, document);
