var SV = window.SV || {};
SV.AdvancedBBCode = SV.AdvancedBBCode || {};
SV.AdvancedBBCode.EditorFirstStart = SV.AdvancedBBCode.EditorFirstStart || [];

(/** @param {jQuery} $ jQuery Object */ function ($, window, document, _undefined) {
    "use strict";

    SV.AdvancedBBCode.wrapTextPatch = {
        shimWrapSelectionText: function () {
            var originalFn = XF.EditorHelpers.wrapSelectionText;
            XF.EditorHelpers.wrapSelectionText = function (ed, before, after, save, inline) {

                if (save) {
                    ed.selection.save();
                }
                ed.undo.saveStep();

                var $wrapper = $('<div></div>'),
                    $markers = ed.$el.find('.fr-marker'),
                    html = null,
                    selectedHtml = '';
                if (!ed.selection.isCollapsed()) {
                    // markers may be touched by getSelected
                    $wrapper.append($markers.last().get(0));

                    // always disable the mozilla special-handling which fails in wierd ways
                    var oldMozilla = ed.browser.mozilla;
                    ed.browser.mozilla = 0;
                    try {
                        selectedHtml = ed.html.getSelected();
                    } finally {
                        ed.browser.mozilla = oldMozilla;
                    }

                    if (/<p>/i.test(selectedHtml)) {
                        // avoid injecting additional new-lines when selected spans new-lines
                        if (inline) {
                            var $frag = $('<div />').html(selectedHtml);
                            var $p = $frag.children('p');
                            $p.first().prepend(XF.htmlspecialchars(before));
                            $p.last().append($wrapper.children());
                            $p.last().append(XF.htmlspecialchars(after));

                            // special case that an entire single line has been selected, and instead select the contents of that line
                            if ($p.length === 1 && $frag.contents().length === 1) {
                                html = $p.html();
                            } else {
                                html = $frag.html();
                            }
                        } else {
                            selectedHtml = selectedHtml + $wrapper.html();
                            inline = true;
                        }
                    } else {
                        selectedHtml = selectedHtml + $wrapper.html();
                    }
                } else {
                    $wrapper.append($markers.first().get(0));
                    $wrapper.append($markers.last().get(0));
                    selectedHtml = $wrapper.html();
                }

                if (html === null) {
                    html = XF.htmlspecialchars(before)
                        + selectedHtml
                        + XF.htmlspecialchars(after);
                }

                if (!inline) {
                    html = '<p>' + html + '</p>';
                }
                ed.html.insert(html);

                ed.selection.restore();
                ed.placeholder.hide();
                ed.undo.saveStep();
                XF.EditorHelpers.normalizeAfterInsert(ed);
            }
        },
        setupShimInlineSpoiler: function (cmd) {
            cmd.callback = function () {
                XF.EditorHelpers.wrapSelectionText(this, '[ISPOILER]', '[/ISPOILER]', true, true);
            };
        },
        setupShimInlineCode: function (cmd) {
            cmd.callback = function () {
                XF.EditorHelpers.wrapSelectionText(this, '[ICODE]', '[/ICODE]', true, true);
            };
        },
    };

    SV.AdvancedBBCode.EditorFirstStart.push(function (editorConfig) {
        // patch once the editor start being initialized
        XF.EditorDialogCode = XF.extend(XF.EditorDialogCode, {
            __backup: {
                '_afterShow': 'svAdvancedBbCode_wrapTextPatch_afterShow',
            },
            _afterShow: function(overlay) {
                // calling ed.selection.restore() twice is a no-op, but calling ed.selection.save() twice breaks ed.html.getSelected()
                this.ed.selection.restore();
                this.svAdvancedBbCode_wrapTextPatch_afterShow(overlay);
            }
        });
        // patch the reference to the non-extended version
        XF.EditorHelpers.dialogs.code = new XF.EditorDialogCode('code');

        SV.AdvancedBBCode.wrapTextPatch.shimWrapSelectionText();
        if ($.FE.COMMANDS['xfInlineSpoiler']) {
            SV.AdvancedBBCode.wrapTextPatch.setupShimInlineSpoiler($.FE.COMMANDS['xfInlineSpoiler']);
        }
        if ($.FE.COMMANDS['xfInlineCode']) {
            SV.AdvancedBBCode.wrapTextPatch.setupShimInlineCode($.FE.COMMANDS['xfInlineCode']);
        }
    });

})(jQuery, window, document);
