<?php

namespace SV\AdvancedBbCodesPack\BbCode\Tag;

/**
 * A BB code renderer for [QS] tags (alt [ISPOILER] tag).
 *
 * @package SV\AdvancedBbCodesPack\BbCode\Tag
 */
class QuickSpoiler extends AbstractTag
{
    /**
     * @param array           $tagChildren
     * @param null|string|string[] $tagOption
     * @param array           $tag
     * @param array           $options
     * @return string|\XF\PreEscaped
     */
    public function render(array $tagChildren, $tagOption, array $tag, array $options)
    {
        if ($options['svNestingInlineSpoiler'] ?? false)
        {
            return $this->renderer->renderSubTree($tagChildren, $options);
        }
        $options['svNestingInlineSpoiler'] = true;

        $contents = $this->renderer->renderSubTree($tagChildren, $options);

        $template = $this->rendererType === 'emailHtml'
            ? 'email:bb_code_tag_ispoiler'
            : 'public:sv_bbcode_spoiler';

        return \trim($this->templater->renderTemplate($template, [
            'content' => $contents
        ]));
    }
}