<?php

namespace SV\AdvancedBbCodesPack\XenAddons\AMS\Entity;

use XF\Util\Arr;
use function array_merge;
use function count;

/**
 * @Extends \XenAddons\AMS\Entity\ArticleItem
 */
class ArticleItem extends XFCP_ArticleItem
{
    /** @noinspection PhpUnusedParameterInspection */
    public function svInjectLdStructuredData(array $output, int $page = 1, array $extraData = []): array
    {
        $templater = \XF::app()->templater();

        $json = $templater->pageParams['svLdJson'] ?? [];
        $json = Arr::filterNull($json, true);
        if (count($json) !== 0)
        {
            $output = array_merge($output, $json);
        }

        return $output;
    }

    public function getLdStructuredData(int $page = 1, array $extraData = []): array
    {
        $output = parent::getLdStructuredData($page, $extraData);

        return $this->svInjectLdStructuredData($output, $page, $extraData);
    }
}